<template>
  <b-button
    variant="success"
    v-b-modal.create-property-modal
    v-show="me && me.groups.includes('MOD')"
  >
    <b-icon-file-plus />
    Property

    <b-modal
      id="create-property-modal"
      :title="`Create ${system.name} property`"
      @ok="submit"
      ok-variant="success"
    >
      <p v-show="error" style="color: red">
        Something went wrong, please double-check your input or try it later
        again. Error message: {{ error }}
      </p>

      <b-form>
        <label for="name">Name</label>
        <b-form-input
          id="name"
          v-model="name"
          :state="name.length >= 3"
          placeholder="Property name"
          trim
        />

        <label for="description">Description</label>
        <b-form-textarea
          id="description"
          v-model="description"
          placeholder="Describe the property"
          trim
        />

        <label for="link">Link</label>
        <b-form-textarea
          id="link"
          v-model="link"
          placeholder="Optional link to more information..."
          trim
        />

        <label for="values">Values (space-separated)</label>
        <b-form-input
          id="values"
          v-model="values"
          placeholder="Space-separated list of values"
          trim
        />
      </b-form>
    </b-modal>
  </b-button>
</template>

<script>
import gql from "graphql-tag";

export default {
  name: "CreateProperty",
  data() {
    return {
      me: {
        groups: []
      },
      error: "",
      name: "",
      description: "",
      link: "",
      values: ""
    };
  },
  apollo: {
    me: {
      query: gql`
        query {
          me {
            id
            name
            groups
            email
            joined
          }
        }
      `
    }
  },
  props: {
    system: Object
  },
  methods: {
    submit(e) {
      e.preventDefault();
      this.$apollo
        .mutate({
          mutation: gql`
            mutation($systemId: ID!, $property: PropertyInput!) {
              createProperty(systemId: $systemId, property: $property) {
                id
              }
            }
          `,
          variables: {
            systemId: this.system.id,
            property: {
              name: this.name || undefined,
              description: this.description || undefined,
              link: this.link || undefined,
              values: this.values.split(" ").filter(v => v) || undefined
            }
          }
        })
        .then(() => location.reload())
        .catch(error => {
          this.error = error;
        });
    }
  }
};
</script>
